<template>
  <div class="messenger">
    <transition-group name="slide-fade">
      <!-- use the index as a key so when a new message replaces an
      old message, it does so without animating.  if we want to
      animate individual messages, you can key on the message ID -->
      <div
        class="message"
        :class="message.type"
        v-for="(message, index) in displayMessages"
        :key="message.id"
      >
        {{ message.content }}
      </div>
    </transition-group>
  </div>
</template>
<style lang="scss" scoped>
@import "~assets/mixins.scss";

.slide-fade-enter-active {
  transition: all 0.3s ease;
}
.slide-fade-leave-active {
  transition: all 0.3s cubic-bezier(1, 0.5, 0.8, 1);
}

.slide-fade-enter {
  transform: translateY(-10px);
  opacity: 0;
}

.slide-fade-leave-to {
  transform: translateY(10px);
  opacity: 0;
}
</style>
<script>
export default {
  props: {
    max: {
      type: Number,
      default: 1,
    },
    timeout: {
      type: Number,
      default: 5000,
    },
  },
  data() {
    return {
      messages: [],
      index: 0,
    };
  },
  beforeDestroy() {
    if (this._intervals) {
      this._intervals.forEach((i) => clearTimeout(i));
    }
  },
  computed: {
    displayMessages() {
      return this.messages.splice(Math.max(this.messages.length - this.max, 0));
    },
  },
  methods: {
    push(in_object) {
      var object = { ...in_object, id: ++this.index };
      this.messages.push(object);

      this._intervals = this._intervals || [];
      this._intervals.push(
        setTimeout(
          () =>
            (this.messages = this.messages.filter((m) => m.id != object.id)),
          object.timeout || this.timeout
        )
      );
    },
    message(content) {
      this.push({ type: "message", content: content });
    },
  },
};
</script>
